#!/bin/bash

#device_list=`ls /dev/sda*[0-9]`

rm -rf $HOME/.caja_unshown_device
rm -rf $HOME/.caja_other_disk
rm -rf $HOME/.caja_device_name
cmdline1=`cat /proc/cmdline |grep UUID`
cmdline2=`cat /proc/cmdline |grep root=live:`
if [ "X${cmdline1}" != "X"  ];then
	UUID=`cat /proc/cmdline|awk -F'UUID=' '{print $2}'|awk '{print $1}'`
	DISK=`ls -l  /dev/disk/by-uuid/${UUID} |awk -F '../../' '{print $2}'`
	root_disk="/dev/$DISK"	
elif [ "X${cmdline2}" != "X"  ];then
	root_disk="live"
else
	root_disk=`cat /proc/cmdline|awk -F'root=' '{print $2}'|awk '{print $1}'`
fi


function get_name()
{
	case $num in
		"0")
			echo $i "(C:)" >> $HOME/.caja_device_name
		;;
		"1")
			echo $i "(D:)" >> $HOME/.caja_device_name
		;;
		"2")	
			echo $i "(E:)" >> $HOME/.caja_device_name
		;;
		"3")	
			echo $i "(F:)" >> $HOME/.caja_device_name
		;;
		"4")	
			echo $i "(G:)" >> $HOME/.caja_device_name
		;;
		"5")	
			echo $i "(H:)" >> $HOME/.caja_device_name
		;;
		"6")	
			echo $i "(I:)" >> $HOME/.caja_device_name
		;;
		"7")	
			echo $i "(J:)" >> $HOME/.caja_device_name
		;;
		"8")	
			echo $i "(K:)" >> $HOME/.caja_device_name
		;;
		"9")	
			echo $i "(L:)" >> $HOME/.caja_device_name
		;;
		"10")	
			echo $i "(M:)" >> $HOME/.caja_device_name
		;;
		"11")	
			echo $i "(N:)" >> $HOME/.caja_device_name
		;;
		"12")	
			echo $i "(O:)" >> $HOME/.caja_device_name
		;;
		"13")	
			echo $i "(P:)" >> $HOME/.caja_device_name
		;;
		"14")	
			echo $i "(Q:)" >> $HOME/.caja_device_name
		;;
		"15")	
			echo $i "(R:)" >> $HOME/.caja_device_name
		;;
		"16")	
			echo $i "(S:)" >> $HOME/.caja_device_name
		;;
		"17")	
			echo $i "(T:)" >> $HOME/.caja_device_name
		;;
		"18")	
			echo $i "(U:)" >> $HOME/.caja_device_name
		;;
		"19")	
			echo $i "(V:)" >> $HOME/.caja_device_name
		;;
		"20")	
			echo $i "(W:)" >> $HOME/.caja_device_name
		;;
		"21")	
			echo $i "(X:)" >> $HOME/.caja_device_name
		;;
		"22")	
			echo $i "(Y:)" >> $HOME/.caja_device_name
		;;
		"23")	
			echo $i "(Z:)" >> $HOME/.caja_device_name
		;;
		*)
			echo $i "Unknown" >> $HOME/.caja_device_name
		;;
	esac
}
if [ "X${root_disk}" != "Xlive" ];then
	disk_num=2
	disk=`echo ${root_disk:0:8}`
	num=0
	home_device=""
	other_disk=`ls /dev/[s,h]d[a-z] |grep -v ${disk}`
	if [ -f "/var/tmp/.all_disk_install" ];then
		all_disk_install=`cat /var/tmp/.all_disk_install|grep yes`
	else
		all_disk_install=""
	fi
	if [ "X${all_disk_install}" != "X" ];then
		#all disk install do not show sda3 because it is backup
		device_list=`ls ${disk}*[0-9] |grep -v ${disk}3 |sort -k 1.9 -n`
	else
		device_list=`ls ${disk}*[0-9] |sort -k 1.9 -n`
	fi
	if [ "X${other_disk}" != "X" ];then
		for i in ${other_disk}
		do
			echo $i $disk_num >> $HOME/.caja_other_disk
			disk_num=`expr $disk_num + 1`
		done
	fi




	for i in ${device_list}
	do
		device_info=`udisksctl info -b $i`
		#device_type=`udisksctl info -b $i|grep 'Type'|grep -v 'IdType'|awk '{print $2}'`
		device_type=`echo -e "$device_info"|grep 'Type'|grep -v 'IdType'|awk '{print $2}'`
		no_filesystem_device=`echo -e "$device_info"|grep 'IdUsage'|awk '{print $2}'|grep 'filesystem'`
		swap_device=`echo "$device_type"|grep 0x82`
		extend_device=`echo "$device_type"|grep 0x05`
		mount_points=`echo -e "$device_info"|grep 'MountPoints'|awk '{print $2}'`
		boot_device=""
		Name=`echo -e "$device_info" |grep -w "Name:" |awk '{print $2}'`
		if [ "${mount_points}" == "/boot/efi" -a "${Name}" == "EFI" ]; then
			continue
		fi
		if [ "${mount_points}" == "/home" ]; then
		            mount_IdUUID=`echo -e "$device_info"|grep 'IdUUID'|awk '{print $2}'`
			    tmp=`cat /etc/fstab | grep "/home" | grep "UUID="`
			    if [ "X${tmp}" != "X" ];then
		            	fstab_UUID=`cat /etc/fstab | grep "/home" | cut -d '=' -f2 | awk '{print $1}'` 
		            	if [ "$mount_IdUUID" == "$fstab_UUID" ]; then
		                    home_device="$i"
		            	fi
			    else
			    	tmp=`cat /etc/fstab | grep "/home"`
				if [ "X${tmp}" != "X" ];then
				    home_device="$i"
				fi
			    fi
		fi  
		if [ "${mount_points}" == "/diskE" ]; then
                            mount_IdUUID=`echo -e "$device_info"|grep 'IdUUID'|awk '{print $2}'`
                            tmp=`cat /etc/fstab | grep "/diskE" | grep "UUID="`
                            if [ "X${tmp}" != "X" ];then
                                fstab_UUID=`cat /etc/fstab | grep "/diskE" | cut -d '=' -f2 | awk '{print $1}'`
                                if [ "$mount_IdUUID" == "$fstab_UUID" ]; then
                                    diskE_device="$i"
                                fi
                            else
                                tmp=`cat /etc/fstab | grep "/diskE"`
                                if [ "X${tmp}" != "X" ];then
                                    diskE_device="$i"
                                fi
                            fi
                fi

		if [ "${mount_points}" == "/boot" ]; then
			mount_IdUUID=`echo -e "$device_info"|grep 'IdUUID'|awk '{print $2}'`
			fstab_UUID=`cat /etc/fstab | grep "/boot" | cut -d '=' -f2 | awk '{print $1}'`
			if [ "$mount_IdUUID" == "$fstab_UUID" ]; then
				boot_device="$i"
			fi
		fi	
		if [ "X$extend_device" == "X" ];then
			extend_device=`echo "$device_type"|grep 0x0f`
		fi

		if [ "X${swap_device}" != "X" -o "X${extend_device}" != "X" -o "X${device_type}" == "X" -o "X${no_filesystem_device}" == "X" -o "X${boot_device}" != "X" ];then
			#we dont not show in caja
			echo "not show" > /dev/null
		else
			get_name
			num=`expr $num + 1`
		fi
	done

	if [ -f $HOME/.caja_device_name ];then
		root_disk_label=`cat $HOME/.caja_device_name|grep "$root_disk " |awk '{print  $2}'`
		echo $root_disk $root_disk_label > $HOME/.caja_root_disk_name
		if [ "X${home_device}" != "X" ]; then
			home_disk_label=`cat $HOME/.caja_device_name|grep "$home_device " |awk '{print  $2}'`
			echo $home_disk_label > $HOME/.caja_home_disk_name
		fi
		if [ "X${diskE_device}" != "X" ]; then
                        diskE_disk_label=`cat $HOME/.caja_device_name|grep "$diskE_device " |awk '{print  $2}'`
                        echo $diskE_disk_label > $HOME/.caja_diskE_name
                fi

	fi
else
	echo ${root_disk} > $HOME/.caja_root_disk_name
	disk_num=1
        other_disk=`ls /dev/[s,h]d[a-z]`
        if [ "X${other_disk}" != "X" ];then
                for i in ${other_disk}
                do
                        echo $i $disk_num >> $HOME/.caja_other_disk
			num=0
                        disk_num=`expr $disk_num + 1`
			device_list=`ls ${i}*[0-9] |sort -k 1.9 -n`
			for i in ${device_list}
        		do
                		device_info=`udisksctl info -b $i`
                		device_type=`echo -e "$device_info"|grep 'Type'|grep -v 'IdType'|awk '{print $2}'`
                		no_filesystem_device=`echo -e "$device_info"|grep 'IdUsage'|awk '{print $2}'|grep 'filesystem'`
                		swap_device=`echo "$device_type"|grep 0x82`
				if [ "X${swap_device}" != "X"  -o "X${device_type}" == "X" -o "X${no_filesystem_device}" == "X" ];then
                        		echo "not show" > /dev/null
                		else
                        		get_name
                        		num=`expr $num + 1`
                		fi
			done
                done
        fi	
fi
